'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RelationError = exports.InexistentDbObjectError = exports.EmptyDbObjectError = exports.DbObjectAlreadyRegisteredError = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ExtendableError = function (_Error) {
  (0, _inherits3.default)(ExtendableError, _Error);

  function ExtendableError(message) {
    (0, _classCallCheck3.default)(this, ExtendableError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ExtendableError).call(this, message));

    _this.message = message;
    _this.name = _this.constructor.name;

    _this.stack = new Error(message).stack;
    return _this;
  }

  return ExtendableError;
}(Error);

/**
 * An error which gets thrown when an attempt is made to register a database
 * object multiple times.
 * @extends Error
 * @property {string} name Name of the database object in question.
 */


var DbObjectAlreadyRegisteredError = exports.DbObjectAlreadyRegisteredError = function (_ExtendableError) {
  (0, _inherits3.default)(DbObjectAlreadyRegisteredError, _ExtendableError);

  function DbObjectAlreadyRegisteredError(name) {
    (0, _classCallCheck3.default)(this, DbObjectAlreadyRegisteredError);

    var _this2 = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(DbObjectAlreadyRegisteredError).call(this, 'Database object with name \'' + name + '\' cannot be registered multiple times'));

    _this2.name = name;
    return _this2;
  }

  return DbObjectAlreadyRegisteredError;
}(ExtendableError);

/**
 * An error which gets thrown when an attempt is made to store an empty database
 * object.
 * @extends Error
 */


var EmptyDbObjectError = exports.EmptyDbObjectError = function (_ExtendableError2) {
  (0, _inherits3.default)(EmptyDbObjectError, _ExtendableError2);

  function EmptyDbObjectError() {
    (0, _classCallCheck3.default)(this, EmptyDbObjectError);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(EmptyDbObjectError).call(this, 'Empty database object cannot be stored'));
  }

  return EmptyDbObjectError;
}(ExtendableError);

/**
 * An error which gets thrown when an attempt is made to modify an inexistent
 * database object.
 * @extends Error
 */


var InexistentDbObjectError = exports.InexistentDbObjectError = function (_ExtendableError3) {
  (0, _inherits3.default)(InexistentDbObjectError, _ExtendableError3);

  function InexistentDbObjectError() {
    (0, _classCallCheck3.default)(this, InexistentDbObjectError);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(InexistentDbObjectError).call(this, 'Database object does not exist'));
  }

  return InexistentDbObjectError;
}(ExtendableError);

/**
 * An error which gets thrown when a Relation does not behave as expected.
 * @extends Error
 */


var RelationError = exports.RelationError = function (_ExtendableError4) {
  (0, _inherits3.default)(RelationError, _ExtendableError4);

  function RelationError() {
    (0, _classCallCheck3.default)(this, RelationError);
    return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(RelationError).call(this, 'One-to-one and many-to-one Relations cannot be re-assigned'));
  }

  return RelationError;
}(ExtendableError);
//# sourceMappingURL=errors.js.map