'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _entries = require('babel-runtime/core-js/object/entries');

var _entries2 = _interopRequireDefault(_entries);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

exports.camelizeKeys = camelizeKeys;
exports.flattenArray = flattenArray;
exports.modelize = modelize;
exports.requireUncached = requireUncached;

var _inflection = require('inflection');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function camelizeKeys(obj) {
  // Support recursive array transformation
  if (Array.isArray(obj)) {
    return obj.map(function (item) {
      return camelizeKeys(item);
    });
  }

  var result = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)((0, _entries2.default)(obj)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var _step$value = (0, _slicedToArray3.default)(_step.value, 2);

      var key = _step$value[0];
      var value = _step$value[1];

      result[(0, _inflection.camelize)(key, true)] = value;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return result;
}

function flattenArray(value) {
  return [].concat.apply([], value);
}

function modelize(obj, Model) {
  // Support recursive array transformation
  if (Array.isArray(obj)) {
    return obj.map(function (item) {
      return modelize(item, Model);
    });
  }

  // Don't modelize non-objects
  return obj instanceof Object ? new Model(obj, false) : obj;
}

function requireUncached(modulePath) {
  delete require.cache[require.resolve(modulePath)];
  return require(modulePath).default;
}
//# sourceMappingURL=utils.js.map